/*	$SunId: @(#)md_mddb.h 1.27 91/04/02 SMI [RMTC] $	*/

#include <sys/ioccom.h>

#if 0
#define	MDDB_FAKE
#endif

/* Make it easy to compile-time change the allocator */
#define	MD_ZALLOC(a)		MD_NEW_ZALLOC((a), KMEM_SLEEP)
#define	MD_NEW_ZALLOC(a, b)	new_mdmem_alloc((a), (b))

caddr_t	new_mdmem_alloc();

typedef int	mddb_recid_t;

enum mddb_type	{MDDB_ALL, MDDB_DEVICE, MDDB_MIRROR, MDDB_RESYNC,
	MDDB_HS, MDDB_HSP};
enum mddb_cfgcmd {MDDB_USEDEV, MDDB_NEWDEV, MDDB_DELDEV, MDDB_GETDEV,
	MDDB_ENDDEV};
enum mddb_recstatus	  {MDDB_NORECORD, MDDB_NODATA, MDDB_OK, MDDB_STALE};


#define	MDDB_E_INVALID	(-1)	/* an invalid argument was passed */
#define	MDDB_E_EXISTS	(-2)	/* doing an operation a 2nd time which can */
				/*	only be done once */
#define	MDDB_E_MASTER	(-3)	/* problem occurred accessing mastor block */
				/*	returned from NEW_DEV	*/
#define	MDDB_E_TOOSMALL	(-4)	/* device is not large enough */
#define	MDDB_E_NORECORD	(-5)	/* record does not exits */
				/*
					returned from:	mddb_getnextrec
							mddb_getrecsize
							mddb_commitrec
							mddb_commitrecs
							mddb_deleterec
							mddb_lockrec
							mddb_lockrecs */
#define	MDDB_E_NOSPACE	(-6)	/* no space to create record */
#define	MDDB_E_NOTNOW	(-7)	/* do not presently have enough resources */
				/*	to perform requested operation */
#define	MDDB_E_NODB	(-8)	/* no database exist */
#define	MDDB_E_IO	(-9)	/* io error occured */
#define	MDDB_E_SETUP	(-10)	/* data base already read in */
#define	MDDB_E_NOBLK	(-11)	/* error in logical to physical blk trans */

#define	MDDB_F_EREAD	0x0001	/* a read error occurred */
#define	MDDB_F_TOOSMALL	0x0002	/* replica is to small to hold data base */
#define	MDDB_F_EFMT	0x0004	/* something is wrong with the data */
#define	MDDB_F_EDATA	0x0008	/* error in data blocks */
#define	MDDB_F_EMASTER	0x0010	/* error in master block(s) */


#define	MDDB_F_ACTIVE	0x0020	/* this mddb is currently being used */
#define	MDDB_F_EWRITE	0x0040	/* a write error occurred */
#define	MDDB_F_MASTER	0x0080	/* this is the copy which was used as input */
#define	MDDB_F_SUSPECT	0x0100	/* ability to write this replica is suspect */
#define	MDDB_F_OPT	0x0200	/* this record is an optimization record */
#define	MDDB_F_PTCHED	0x0400	/* database location was patched in kernel */
#define	MDDB_F_IOCTL	0x0800	/* database location passed in from ioctl */
#define	MDDB_F_GOTTEN	0x1000	/* getdev has been done on this device */
#define	MDDB_F_LOCACC	0x2000	/* the locator has been accessed */
#define	MDDB_F_UP2DATE	0x4000	/* this copy of data base is known up to date */
#define	MDDB_F_OLDACT	0x8000	/* this copy was active in previous kernel */

#define	MDDB_MAXFLAG 16

#define	MDDB_MINBLKS		  16	/* enough for a few metadevices */
#define	MDDB_MAXBLKS		8192	/* size of free bit map (must be / 8) */

#define	MDDB_C_STALE	0x0001
#define	MDDB_C_TOFEW	0x0002

#ifndef MDDB_FAKE

extern int			mddb_configure();
extern mddb_recid_t		mddb_getnextrec();
extern caddr_t			mddb_getrecaddr();
extern int			mddb_getrecsize();
extern int			mddb_commitrec();
extern int			mddb_commitrecs();
extern int			mddb_deleterec();
extern enum mddb_recstatus	mddb_getrecstatus();
extern mddb_recid_t		mddb_createrec();
extern int			mddb_lockrec();
extern int			mddb_lockrecs();
extern void			mddb_unlockrec();
extern void			mddb_unlockrecs();

#else

caddr_t mddb_fakeit;

#define	mddb_configure(a, b)	(0)
#define	mddb_getnextrec(a, b)	((mddb_recid_t)0)
#define	mddb_getrecaddr(a)	(mddb_fakeit)
#define	mddb_getrecsize(a)	(0)
#define	mddb_commitrec(a)	(0)
#define	mddb_commitrecs(a)	(0)
#define	mddb_deleterec(a)	(0)
#define	mddb_getrecstatus(a)	(MDDB_OK)
#define	mddb_createrec(s, a, b)	(0xffff & (int)(mddb_fakeit = \
					(caddr_t)kmem_alloc(s)))
#define	mddb_lockrec(a)		(0)
#define	mddb_unlockrecs(a)	(0)
#define	mddb_unlockrec(a)	(0)
#define	mddb_lockrecs(a)	(0)

#endif

struct mddb_locator {
	dev_t		l_dev;
	daddr_t		l_blk;
	int		l_flags;
};

struct mddb_config {
	int			c_id;	/* used with get next locator */
	int			c_status;	/* how command worked */
	struct mddb_locator	c_locator;
	int			c_dbcount;	/* number of dbs */
	int			c_dbmax;	/* maximum number of dbs */
	int			c_flags;
	int			c_dbend;	/* size of database */
	int			c_spare[16];	/* unused must be zero */
};


#define	MD_DB_NEWDEV   _IOWR(V, 100, struct mddb_config)
#define	MD_DB_USEDEV   _IOWR(V, 101, struct mddb_config)
#define	MD_DB_GETDEV   _IOWR(V, 102, struct mddb_config)
#define	MD_DB_DELDEV   _IOWR(V, 103, struct mddb_config)
#define	MD_DB_ENDDEV   _IOWR(V, 104, struct mddb_config)


/*
 * the rest of this file is of interest only to md_mddb.c
 */

#define	MDDB_MAX_PATCH	50		/* number of locations that */
					/*	can be patched in kernal */

#ifdef MDDB

#define	MDDB_MAGIC_MB	0x6d646d62	/* magic number for master blocks */
#define	MDDB_MAGIC_DB	0x6d646462	/* magic number for directory blocks */
#define	MDDB_MAGIC_RB	0x6d647262	/* magic number for record blocks */
#define	MDDB_MAGIC_LB	0x6d646c62	/* magic number for locator blocks */

#define	MDDB_GLOBAL_XOR 1234567890

#define	MDDB_CRCMAGIC 987654

#define	MDDB_REV_MAJOR  (u_int)0xff00
#define	MDDB_REV_MINOR  (u_int)0x00ff

#define	MDDB_REV_MB	(u_int)0x0101
#define	MDDB_REV_DB	(u_int)0x0101
#define	MDDB_REV_LB	(u_int)0x0102
#define	MDDB_REV_RB	(u_int)0x0100

typedef int	mddb_block_t;

struct mddb_map {
	u_int		m_consecutive;
	daddr_t		m_firstblk;
};
struct mddb_mb {
	int		mb_magic;
	u_int		mb_revision;
	int		mb_checksum;
	struct mddb_mb *mb_next;
	daddr_t		mb_nextblk;
	struct timeval	mb_timestamp;
	int		mb_blkcnt;
	dev_t		mb_device;
	short		spareshort;
	daddr_t		mb_thisblk;
	int		spares[14];
	struct mddb_map	mb_blkmap[50];
};

struct mddb_old_lb {
	int		lb_magic;
	u_int		lb_revision;
	int		lb_checksum;
	u_int		lb_commitcnt;
	struct timeval	lb_timestamp;
	int		lb_loccnt;
	struct mddb_locator	lb_locators[10];
};

struct mddb_lb {
	int		lb_magic;
	u_int		lb_revision;
	int		lb_checksum;
	u_int		lb_commitcnt;
	struct timeval	lb_timestamp;
	int		lb_loccnt;
	int		lb_machineid;
	struct timeval	lb_inittime;
	struct mddb_locator	lb_locators[10];
};


/*
 * there can be no address in record block. The checksum must
 * stay the same where ever the record is in memory. Many
 * things depend on this. Also the timestamp is the time the the
 * record was committed not the time it was written to a particular
 * device.
 */
struct mddb_rb{
	u_int		rb_magic;
	u_int		rb_revision;
	u_int		rb_checksum;
	u_int		rb_checksum_fiddle;
	u_int		rb_lock;
	u_int		rb_commitcnt;
	u_int		rb_spare[1];
	struct timeval	rb_timestamp;
	int		rb_data[1];
};

/*
 * directory entries
 */
struct mddb_de{
	struct mddb_de *de_next;
	struct mddb_rb *de_rb;
	mddb_recid_t	de_recid;
	enum mddb_type	de_type;
	u_int		de_reqsize;
	u_int		de_recsize;
	u_int		de_blkcount;
	u_int		de_flags;
	struct mddb_locator	de_locators[3];
	mddb_block_t	de_blks[1];
};

struct mddb_db{
	u_int		db_magic;
	u_int		db_revision;
	u_int		db_checksum;
	mddb_block_t	db_blknum;
	struct mddb_db *db_next;
	mddb_block_t	db_nextblk;
	struct timeval	db_timestamp;
	u_int		db_recsum;
	struct mddb_de *db_firstentry;
};


	/*
	 *information about a replica of the data base
	 */
struct mddb_ri {
	struct mddb_ri		*ri_next;
	u_int			 ri_flags;
	int			 ri_commitcnt;
	int			 ri_transplant;
	struct mddb_locator	 ri_loc;
	struct mddb_mb		*ri_mbp;
	struct mddb_lb		*ri_lbp;
};

struct mddb_bf {
	struct mddb_bf		*bf_next;
	struct mddb_locator	*bf_locator;
	struct buf		bf_buf;
};

#define	MDDB_NOSLEEP	1
#define	MDDB_SLEEPOK	0

#define	MDDB_NOOLDOK	1
#define	MDDB_MUSTEXIST	0

#define	MDDB_SCANALL	1
#define	MDDB_RETRYSCAN	0

#define	MDDB_PROBE	1
#define	MDDB_NOPROBE	0

#define	MDDB_L_LOCKED	0x0001	/* this record is locked */
#define	MDDB_L_WANTED	0x0002

#define	crcgen(record, result, size, skip)		crcgenit(\
	(u_char*)(record), (u_char*)(result), (u_int)(size), (u_char*)(skip))

#define	crcchk(record, result, size, skip)	crcchkit(\
	(u_char*)(record), (u_char*)(result), (u_int)(size), (u_char*)(skip))
#endif
